Bug 11773 - OS X remote arch detection
OS X remote arch detection
Product: Samba 4.1 and newer
Classification: Unclassified
Component: File services
All All
: P5 normal
: ---
Assigned To: Ralph Böhme
Samba QA Contact
Depends on:
  Show dependency treegraph
Reported: 2016-03-04 09:30 UTC by Ralph Böhme
Modified: 2016-08-02 10:54 UTC (History)
2 users (show)

See Also:

Patch for 4.3 cherry-picked from master (11.46 KB, patch)
2016-03-04 13:40 UTC, Ralph Böhme
jra: review+
Patch for 4.4 cherry-picked from master (11.46 KB, patch)
2016-03-04 13:41 UTC, Ralph Böhme
jra: review+
Patch for 4.2 backported from master (11.41 KB, patch)
2016-03-04 13:42 UTC, Ralph Böhme
jra: review+

Note You need to log in before you can comment on or make changes to this bug.
Description Ralph Böhme 2016-03-04 09:30:17 UTC
We should provide backports for the patches that recently landed in master which fix the OS X client remote arch detection.

This can useful for employing a server side workaround for bug #11596

Will attach backports once I have this bugs bug id.
Comment 1 Ralph Böhme 2016-03-04 13:40:43 UTC
Created attachment 11897 [details]
Patch for 4.3 cherry-picked from master
Comment 2 Ralph Böhme 2016-03-04 13:41:24 UTC
Created attachment 11898 [details]
Patch for 4.4 cherry-picked from master
Comment 3 Ralph Böhme 2016-03-04 13:42:06 UTC
Created attachment 11899 [details]
Patch for 4.2 backported from master
Comment 4 Jeremy Allison 2016-03-04 18:36:51 UTC
Re-assigning to Karolin for inclusion in 4.4.0, 4.3.next, 4.2.next.
Comment 5 Karolin Seeger 2016-03-14 08:58:17 UTC
(In reply to Jeremy Allison from comment #4)
Pushed to autobuild-v4-[4|3|2]-test.
Comment 6 John Mulligan 2016-03-15 19:44:46 UTC
FWIW, the remote arch detection for OS X works well on initial connect, but if the smbd services are restarted on the server and OS X clients reconnect they are not identified as OSX.

I was informed that this was due to the client doing a direct SMB2 negprot instead of a SMB1 negprot where the fingerprinting happens.

So this is helpful as a best-effort tool for debugging, but not as a reliable way to configure smbd.
Comment 7 Karolin Seeger 2016-03-21 11:41:05 UTC
(In reply to Karolin Seeger from comment #5)
Pushed to all branches.
Closing out bug report.

Comment 8 Björn Jacke 2016-03-22 08:42:32 UTC
reopening this bug because:

(1) the man page needs to be adopted also

(2) I think comment #6 is an important point - Ralph do you see a way to make the detection work also for reconnecting clients?
Comment 9 Björn Jacke 2016-03-22 09:04:39 UTC
ahm, for the man page, OSX we had that already documented for %a.

For the reconnecting clients the problem is more difficult, as the SMB2 negprot of the reconnecting clients does not contain the protocols that we use to fingerprint the client OS. We might put the result of the SMB1 negprog arch detection into a cache though and use the cached result when a SMB2 negprog comes in. This *might* be a way to fix reconnecting clients.
Comment 10 Ralph Böhme 2016-08-02 10:54:02 UTC
This is addressed by the patch series git log -4 a2c59d3e45e71b44d9135b35c1cf5522e04dec0e in master. The patches are also in 4.5, but not in older versions.

Closing as fixed.